{%- for service in services %}
  {%- set upstreams = [] %}

  {%- for mapping in service["mappings"] %}
    {%- set source_host = mapping["source"] | urlsplit("hostname") %}
    {%- set source_path = mapping["source"] | urlsplit("path") %}
    {%- if source_path is not regex("/$") %}
      {%- set source_path = source_path + "/" %}
    {%- endif %}

    {%- set target_scheme = mapping["target"] | urlsplit("scheme") %}
    {%- set target_is_tls = true if target_scheme == 'https' else false %}
    {%- set target_default_port = target_is_tls | ternary(443, 80) %}
    {%- set target_port = mapping["target"] | urlsplit("port") | default(target_default_port, true) %}
    {%- set target_host = mapping["target"] | urlsplit("hostname") %}

    {%- set upstream_id = "{}_{}".format(mapping["source"], mapping["target"]) | hash("md5") %}

    ###############################################################################
    ### UPSTREAM:
    ###   SOURCE: {{ mapping["source"] }}
    ###   TARGET: {{ mapping["target"] }}
    ###############################################################################

    upstream {{ upstream_id }} {
      # Memory shared zone for dns pool cache
      zone {{ upstream_id }} 1024k;
      {%- if nginx_plus_enabled %}
      server {{ target_host }}:{{ target_port }} resolve route={{ upstream_id }};
      sticky cookie srv_id expires=1h domain={{ source_host }} path={{ source_path }};
      {%- else %}
      server {{ target_host }}:{{ target_port }} resolve;
      {%- endif %}
    }
  {%- endfor %}
{%- endfor %}
